Index: src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/Eml210SAXHandler.java	(revision 5311)
@@ -63,39 +63,33 @@
  */
 public class Eml210SAXHandler extends DBSAXHandler implements AccessControlInterface {
 
-	private boolean processTopLevelAccess = false;
+	private boolean processingTopLevelAccess = false;
 
-	private boolean processAdditionalAccess = false;
+	private boolean processingAdditionalAccess = false;
 
-	private boolean processOtherAccess = false;
+	private boolean processingOtherAccess = false;
 
 	private AccessSection accessObject = null;
 
 	private AccessRule accessRule = null;
 
-	private Vector<AccessSection> accessObjectList = new Vector<AccessSection>(); // store
-																					// every
-																					// access
-																					// rule
+	// all access rules
+	private Vector<AccessSection> accessObjectList = new Vector<AccessSection>(); 
 
 	private Hashtable<String, AccessSection> topLevelAccessControlMap = new Hashtable<String, AccessSection>();
 
-	private Hashtable<String, AccessSection> additionalAccessControlMap = new Hashtable<String, AccessSection>();// store
-
-	// subtree access for single additionalmetacat
-	private Vector<Hashtable<String, AccessSection>> additionalAccessMapList = new Vector<Hashtable<String, AccessSection>>();// store
-																																// maps
-																																// for
-
-	// every additionalmetadata
-	private Vector<String> describesId = new Vector<String>(); // store the ids
-																// in
-
-	// additionalmetadata/describes
+	// subtree access for additionalmetadata
+	private Hashtable<String, AccessSection> additionalAccessControlMap = new Hashtable<String, AccessSection>();
+	
+	
+	private Vector<Hashtable<String, AccessSection>> additionalAccessMapList = new Vector<Hashtable<String, AccessSection>>();
+	
+	// ids from additionalmetadata/describes
+	private Vector<String> describesId = new Vector<String>(); 
+	
 	private Stack<SubTree> subTreeInfoStack = new Stack<SubTree>();
 
-	private Vector<SubTree> subTreeList = new Vector<SubTree>();// store the
-																// final subtree
+	private Vector<SubTree> subTreeList = new Vector<SubTree>();
 	
 	private boolean needToCheckAccessModule = false;
 
@@ -204,8 +198,6 @@
 		try {
 			PermissionController control = new PermissionController(docid
 					+ PropertyService.getProperty("document.accNumSeparator") + revision);
-			// unChangableSubTreeHash = getUnchangableSubTree(control, user,
-			// groups);
 
 			// If the action is update and user doesn't have "ALL" permission
 			// we need to check if user can update access subtree			
@@ -333,13 +325,12 @@
 			if (hitTextNode && parentNode != null) {
 
 				// compare top level access module
-				if (processTopLevelAccess && needToCheckAccessModule) {
-					compareTextNode(currentUnchangeableAccessModuleNodeStack, textBuffer,
-							UPDATEACCESSERROR);
+				if (processingTopLevelAccess && needToCheckAccessModule) {
+					compareAccessTextNode(currentUnchangeableAccessModuleNodeStack, textBuffer);
 				}
 
 				if (needToCheckAccessModule
-						&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
+						&& (processingAdditionalAccess || processingOtherAccess || processingTopLevelAccess)) {
 					// stored the pull out nodes into storedNode stack
 					NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT", null,
 							null, MetacatUtil.normalize(textBuffer.toString()));
@@ -482,13 +473,13 @@
 			// handle access stuff
 			if (localName.equals(ACCESS)) {
 				if (parentNode.getTagName().equals(EML)) {
-					processTopLevelAccess = true;
+					processingTopLevelAccess = true;
 				} else if (parentNode.getTagName() == DISTRIBUTION) {
-					processAdditionalAccess = true;
+					processingAdditionalAccess = true;
 				} else {
 					// process other access embedded into resource level
 					// module
-					processOtherAccess = true;
+					processingOtherAccess = true;
 				}
 				// create access object
 				accessObject = new AccessSection();
@@ -500,13 +491,13 @@
 				accessObject.setSubTreeId(accessId);
 				accessObject.setStartNodeId(startNodeId);
 				accessObject.setDocId(docid);
-				if (processAdditionalAccess) {
+				if (processingAdditionalAccess) {
 					accessObject.setDataFileName(inlineDataFileName);
 				}
 
 				// load top level node stack to
 				// currentUnchangableAccessModuleNodeStack
-				if (processTopLevelAccess && needToCheckAccessModule) {
+				if (processingTopLevelAccess && needToCheckAccessModule) {
 					// get the node stack for
 					currentUnchangeableAccessModuleNodeStack = topAccessSection
 							.getSubTreeNodeStack();
@@ -552,7 +543,7 @@
 			nodeIndex.addElement(currentNode);
 
 			// compare top access level module
-			if (processTopLevelAccess && needToCheckAccessModule) {
+			if (processingTopLevelAccess && needToCheckAccessModule) {
 				compareElementNameSpaceAttributes(
 						currentUnchangeableAccessModuleNodeStack, namespaces, atts,
 						localName, UPDATEACCESSERROR);
@@ -561,7 +552,7 @@
 
 			// store access module element and attributes into stored stack
 			if (needToCheckAccessModule
-					&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
+					&& (processingAdditionalAccess || processingOtherAccess || processingTopLevelAccess)) {
 				// stored the pull out nodes into storedNode stack
 				NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "ELEMENT", localName,
 						prefix, MetacatUtil.normalize(null));
@@ -724,32 +715,32 @@
 	}
 
 	/* method to compare current text node and node in db */
-	private void compareTextNode(Stack<NodeRecord> nodeStack, StringBuffer text,
-			String error) throws SAXException {
+	private void compareAccessTextNode(Stack<NodeRecord> nodeStack, StringBuffer text) throws SAXException {
 		NodeRecord node = null;
 		// get node from current stack
 		try {
 			node = nodeStack.pop();
 		} catch (EmptyStackException ee) {
-			logMetacat.error("Node stack is empty for text data in startElement");
-			throw new SAXException(error);
+			logMetacat.error("Node stack is empty for text data in startElement for doc id " + docid);
+			throw new SAXException("Access rules could not be found in database.");
 		}
-		logMetacat.debug("current node type from xml is TEXT in start element");
-		logMetacat.debug("node type from stack: " + node.getNodeType());
-		logMetacat.debug("current node data from xml is: " + text.toString());
-		logMetacat.debug("node data from stack: " + node.getNodeData());
-		logMetacat.debug("node name from stack: " + node.getNodeName());
-		logMetacat.debug("node is: " + node.getNodeId());
+
+		String dbAccessData = node.getNodeData();
+		String docAccessData = text.toString().trim();
+		
+		logMetacat.debug("Eml210SAXHandler.compareAccessTextNode - \n" +
+					"\t access node type from db:       " + node.getNodeType() + "\n" +
+					"\t access node data from db:       " + node.getNodeData() + "\n" +
+					"\t access node data from document: " + text.toString());
+		
 		if (!node.getNodeType().equals("TEXT")
-				|| !(text.toString()).equals(node.getNodeData())) {
-			logMetacat.error("Inconsistence happened: ");
-			logMetacat.error("current node type from xml is TEXT in start element");
-			logMetacat.error("node type from stack: " + node.getNodeType());
-			logMetacat.error("current node data from xml is: " + text.toString());
-			logMetacat.error("node data from stack: " + node.getNodeData());
-			logMetacat.error("node name from stack: " + node.getNodeName());
-			logMetacat.error("node is: " + node.getNodeId());
-			throw new SAXException(error);
+				|| !docAccessData.equals(dbAccessData)) {
+			logMetacat.warn("Eml210SAXHandler.compareAccessTextNode - Access record mismatch: \n" +
+					"\t access node type from db:       " + node.getNodeType() + "\n" +
+					"\t access node data from db:       " + dbAccessData + "\n" +
+					"\t access node data from document: " + docAccessData);
+			
+			throw new SAXException(UPDATEACCESSERROR + " [Eml210SAXHandler.compareAccessTextNode]");
 		}// if
 	}
 
@@ -843,7 +834,7 @@
 					}
 					accessRule.setPermission(permission);
 				} else if (currentTag.equals(REFERENCES)
-						&& (processTopLevelAccess || processAdditionalAccess || processOtherAccess)) {
+						&& (processingTopLevelAccess || processingAdditionalAccess || processingOtherAccess)) {
 					// get reference
 					data = (textBuffer.toString()).trim();
 					// put reference id into accessSection
@@ -858,38 +849,30 @@
 						// vector
 						data = (textBuffer.toString()).trim();
 						handleOnlineUrlDataFile(data);
-						/*
-						 * if (data != null && (data.indexOf(MetacatUtil
-						 * .getProperty("httpserver")) != -1 || data
-						 * .indexOf(MetacatUtil .getProperty("server")) != -1)) { //
-						 * Get docid from url String dataId = MetacatUtil
-						 * .getDocIdWithRevFromOnlineURL(data); // add to vector
-						 * onlineDataFileIdVector.add(dataId); }//if
-						 */
+
 					}// if
 				}// else if
+				
 				// write text to db if it is not inline data
-				// if (!localName.equals(INLINE))
-				{
-					logMetacat.debug("Write text into DB in End Element");
+				logMetacat.debug("Write text into DB in End Element");
 
-					// compare top level access module
-					if (processTopLevelAccess && needToCheckAccessModule) {
-						compareTextNode(currentUnchangeableAccessModuleNodeStack,
-								textBuffer, UPDATEACCESSERROR);
-					}
-					// write text node into db
-					endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer, currentNode);
+				// compare top level access module
+				if (processingTopLevelAccess && needToCheckAccessModule) {
+					compareAccessTextNode(currentUnchangeableAccessModuleNodeStack,
+							textBuffer);
 				}
-				if (needToCheckAccessModule
-						&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
-					// stored the pull out nodes into storedNode stack
-					NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT", null,
-							null, MetacatUtil.normalize(textBuffer.toString()));
-					storedAccessNodeStack.push(nodeElement);
+				// write text node into db
+				endNodeId = writeTextForDBSAXNode(endNodeId, textBuffer, currentNode);
+			}
+			
+			if (needToCheckAccessModule
+					&& (processingAdditionalAccess || processingOtherAccess || processingTopLevelAccess)) {
+				// stored the pull out nodes into storedNode stack
+				NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT", null,
+						null, MetacatUtil.normalize(textBuffer.toString()));
+				storedAccessNodeStack.push(nodeElement);
 
-				}
-			}// if
+			}
 
 			// set hitText false
 			hitTextNode = false;
@@ -943,7 +926,7 @@
 						newAccessObject.setStoredTmpNodeStack(storedAccessNodeStack);
 						accessObjectList.add(newAccessObject);
 					}
-					if (processTopLevelAccess) {
+					if (processingTopLevelAccess) {
 
 						// top level access control will handle whole document
 						// -docid
@@ -951,7 +934,7 @@
 						// reset processtopleveraccess tag
 
 					}// if
-					else if (processAdditionalAccess) {
+					else if (processingAdditionalAccess) {
 						// for additional control put everything in describes
 						// value
 						// and access object into hash
@@ -976,7 +959,7 @@
 				// check if access node stack is empty after parsing top access
 				// module
 
-				if (needToCheckAccessModule && processTopLevelAccess
+				if (needToCheckAccessModule && processingTopLevelAccess
 						&& !currentUnchangeableAccessModuleNodeStack.isEmpty()) {
 
 					logMetacat.error("Access node stack is not empty after "
@@ -993,9 +976,9 @@
 				storedAccessNodeStack = new Stack<NodeRecord>();
 
 				// reset flag
-				processAdditionalAccess = false;
-				processTopLevelAccess = false;
-				processOtherAccess = false;
+				processingAdditionalAccess = false;
+				processingTopLevelAccess = false;
+				processingOtherAccess = false;
 
 			} else if (currentTag.equals(DISTRIBUTION)) {
 				// If the current Distribution is inline or data and it doesn't have an access section
@@ -1045,13 +1028,13 @@
 				String str = new String(ch, start, length);
 
 				// compare top level access module
-				if (processTopLevelAccess && needToCheckAccessModule) {
+				if (processingTopLevelAccess && needToCheckAccessModule) {
 					compareCommentNode(currentUnchangeableAccessModuleNodeStack, str,
 							UPDATEACCESSERROR);
 				}
 				endNodeId = currentNode.writeChildNodeToDB("COMMENT", null, str, docid);
 				if (needToCheckAccessModule
-						&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
+						&& (processingAdditionalAccess || processingOtherAccess || processingTopLevelAccess)) {
 					// stored the pull out nodes into storedNode stack
 					NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "COMMENT", null,
 							null, MetacatUtil.normalize(str));
@@ -1141,13 +1124,13 @@
 			DBSAXNode currentNode = (DBSAXNode) nodeStack.peek();
 				String data = new String(cbuf, start, len);
 				// compare whitespace in access top module
-				if (processTopLevelAccess && needToCheckAccessModule) {
+				if (processingTopLevelAccess && needToCheckAccessModule) {
 					compareWhiteSpace(currentUnchangeableAccessModuleNodeStack, data,
 							UPDATEACCESSERROR);
 				}
 				// Write the content of the node to the database
 				if (needToCheckAccessModule
-						&& (processAdditionalAccess || processOtherAccess || processTopLevelAccess)) {
+						&& (processingAdditionalAccess || processingOtherAccess || processingTopLevelAccess)) {
 					// stored the pull out nodes into storedNode stack
 					NodeRecord nodeElement = new NodeRecord(-2, -2, -2, "TEXT", null,
 							null, MetacatUtil.normalize(data));
Index: README
===================================================================
--- README	(revision 5310)
+++ README	(revision 5311)
@@ -53,14 +53,37 @@
 See the file "docs/user/metacat-<OS>-install.html" for detailed instructions
 for your OS.
 
-Release Notes for 1.9.1:
+Release Notes for 1.9.2:
 ------------------------
 This release primarily holds the addition of the Threshold of Potential
-Concern workflow functionality (TPC).  
+Concern workflow functionality (TPC).  The following issues were addressed:
 
- -- TPC workflow and workflow run pages added to SANParks skin.
-  
- -- Release supports running metacat on Java 1.6 JVM
+* Create a properties file for use by JUnit Tests (Bug 2994)
+* security issue with skins (Bug 3368)
+* reorganize classes into a more functional specific structure (Bug 3510)
+* Add admin names as dropdown in configuration login (Bug 3729)
+* KNB metacat replication error log file is empty (Bug 3885)
+* Create TPC Report web browse/search pages (Bug 4165)
+* Create archive extraction functionality (Bug 4166)
+* Create Workflow Scheduler (Bug 4167)
+* metacat didn't update xml_path_index table while a document was updated (Bug 4367)
+* Enforce permissions for tpc workflow viewing and scheduling (Bug 4420)
+* Fix cross platform TPC GUI issues (Bug 4556)
+* TPC Sanparks page content lenth issue (Bug 4557)
+* Create validate and isAuthorized unit tests (Bug 4558)
+* Cannot insert replication server via gui (Bug 4594)
+* Timed Replication takes many hours and drives the load up on KNB (Bug 4616)
+* [ESA] Update fails when document rev number is missing (Bug 4627)
+* fails to catch some insert and update failures (Bug 4637)
+* must support java 1.6 (Bug 4641)
+* Convert build to pull eml from svn instead of cvs (Bug 4644)
+* handleGetRevisionAndDocTypeAction should search both xml_documents and xml_revisions table (Bug 4645)
+* Metacat couldn't update a document from client, which previous versions only stay in xml_revisions table (Bug 4649)
+* metacat runs out of memory (Bug 4658)
+* ESA skin links are hard coded to data.esa.org (Bug 4698)
+* Update release 1.9.2 release notes (Bug 4707)
+* Handle writing a text node > 4000 characters to the db. (Bug 4708)
+* Metacat should run against Tomcat 6 (Bug 4716)
 
 Release Notes for 1.9.1:
 ------------------------
